#include "allegro.h"
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/time.h>
#include "prototypes.h"

extern int gDebugMode,gFGColor,gBGColor;
extern BITMAP *gBackImage;
extern PALLETE gBackPalette;

int pixdbl = 2;

void error_msg(char *fmt, ...)
{
  va_list va;
  va_start(va, fmt);
  vfprintf(stderr, fmt, va);
  fputc('\n', stderr);
  va_end(va);
}

int screeninited=0;

void LCDputpixel(int x, int y, int p)
{
	int i;
   char s[256];
   int c;

   if(!screeninited)
	{
      clear(screen);
      /* blit the image onto the screen */
      if(gBackImage)
         blit(gBackImage,screen,0,0,(SCREEN_W-gBackImage->w)/2,0,gBackImage->w,gBackImage->h);
		screeninited=1;
	}
   c=(p&1)?gFGColor:gBGColor;
   switch(pixdbl)
   {
   case 0:      
      putpixel(screen,118+(x<<1),100+(y<<1),c);
      break;
   case 1:      
      putpixel(screen,118+(x<<1)  ,100+(y<<1)  ,c);
      putpixel(screen,118+(x<<1)+1,100+(y<<1)  ,c);
      putpixel(screen,118+(x<<1)  ,100+(y<<1)+1,c);
      putpixel(screen,118+(x<<1)+1,100+(y<<1)+1,c);
      break;
   case 2:      
      putpixel(screen,96+(x*3)  ,84+(y*3)  ,c);
      putpixel(screen,96+(x*3)+1,84+(y*3)  ,c);
      putpixel(screen,96+(x*3)  ,84+(y*3)+1,c);
      putpixel(screen,96+(x*3)+1,84+(y*3)+1,c);
      break;
   }
}

void low_redrawlcd()
{
   static int frame=0;

   if(gDebugMode)
      textprintf_centre(screen, font, SCREEN_W/2, 20, gFGColor,"Frame %d",frame++);
}

void redrawlcd()
{
  low_redrawlcd();
}

void checkevents()
{
   static old_up=0;
   static old_dn=0;
   static old_rt=0;
   static old_lt=0;
   static old_a=0;
   static old_b=0;
   static old_m=0;
   static old_s=0;
   char s[256];

   if(key[KEY_UP]   &&!old_up) {      
         old_up=1;
		   keypress(0);
   }
   if(key[KEY_DOWN] &&!old_dn) {      
         old_dn=1;
         keypress(1);
   }
   if(key[KEY_LEFT] &&!old_lt) {      
         old_lt=1;
         keypress(2);
   }
   if(key[KEY_RIGHT]&&!old_rt) {      
         old_rt=1;
         keypress(3);
   }
   if(key[KEY_Z]    &&!old_a) {      
         old_a=1;
         keypress(4);
   }
   if(key[KEY_X]    &&!old_b) {      
         old_b=1;
         keypress(5);
   }
   if(key[KEY_S]    &&!old_s) {      
         old_s=1;
         keypress(6);
   }
   if(key[KEY_M]    &&!old_m) {      
         old_m=1;
         keypress(7);
   }
   if(key[KEY_ESC])
      exit(0);

   if(!key[KEY_UP]   &&old_up) {      
         old_up=0;
         keyrelease(0);
   }
   if(!key[KEY_DOWN] &&old_dn) {      
         old_dn=0;
         keyrelease(1);
   }
   if(!key[KEY_LEFT] &&old_lt) {      
         old_lt=0;
         keyrelease(2);
   }
   if(!key[KEY_RIGHT]&&old_rt) {      
         old_rt=0;
         keyrelease(3);
   }
   if(!key[KEY_Z]    &&old_a) {      
         old_a=0;
         keyrelease(4);
   }
   if(!key[KEY_X]    &&old_b) {      
         old_b=0;
         keyrelease(5);
   }
   if(!key[KEY_S]    &&old_s) {      
         old_s=0;
         keyrelease(6);
   }
   if(!key[KEY_M]    &&old_m) {      
         old_m=0;
         keyrelease(7);
   }
   if(gDebugMode)
      textprintf_centre(screen, font,SCREEN_W/2, 0, gFGColor,"KEYS: %d%d%d%d%d%d%d%d",old_up,old_dn,old_lt,old_rt,old_a,old_b,old_s,old_m);
}

void waitforevents(struct timeval *t)
{
   struct timeval now,dest;

   if(!t)
      return;
   gettimeofday(&dest, NULL);
   dest.tv_sec+=t->tv_sec;
   dest.tv_usec+=t->tv_usec;
   while(dest.tv_usec>1000000)
   {
      dest.tv_sec++;
      dest.tv_usec-=1000000;
   }         
   gettimeofday(&now, NULL);
//   printf("now=%d:%d\ndest=%d:%d\n",now.tv_sec,now.tv_usec,dest.tv_sec,dest.tv_usec);
   while(1)
   {
      gettimeofday(&now, NULL);
      if(now.tv_sec>dest.tv_sec)
         return;
      if(now.tv_sec==dest.tv_sec && now.tv_usec>=dest.tv_usec)
         return;
   }      
}
